# Copyright (c) 2020 Jerome Arbez-Gindre
# frozen_string_literal: true

# Ensure we require the local version and not one we might have
# installed already
require(
  File.join(
    [
      File.dirname(__FILE__),
      'lib',
      'defmastership',
      'version.rb'
    ]
  )
)

Gem::Specification.new do |s|
  s.required_ruby_version = '>= 2.5'
  s.name = 'defmastership'
  s.version = DefMastership::VERSION
  s.author = 'Jérôme Arbez-Gindre'
  s.email = 'jeromearbezgindre@gmail.com'
  s.licenses = ['MIT']
  s.homepage = 'https://gitlab.com/jjag/defmastership/'
  s.platform = Gem::Platform::RUBY
  s.summary = 'Handling of references and definitions with asciidoctor'
  s.files = `git ls-files`.split("\n")
  s.require_paths << 'lib'
  s.extra_rdoc_files = ['README.rdoc', 'defmastership.rdoc']
  s.rdoc_options << '--title defmastership' << '--main README.rdoc' << '-ri'
  s.bindir = 'bin'
  s.executables << 'defmastership'
  s.add_development_dependency('aruba', '~> 1')
  s.add_development_dependency('rake', '~> 13')
  s.add_development_dependency('rdoc', '~> 6')
  s.add_development_dependency('rspec', '~> 3')
  s.add_development_dependency('rubocop', '1.13')
  s.add_development_dependency('rubocop-rake', '~> 0.5')
  s.add_development_dependency('rubocop-rspec', '~> 2.0')
  s.add_development_dependency('simplecov', '~> 0')
  s.add_runtime_dependency('aasm', '~> 5')
  s.add_runtime_dependency('asciidoctor', '~> 2')
  s.add_runtime_dependency('gli', '~> 2')
end
